unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, GenericSave,
  MDISaveItReg;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    OpenButton: TSpeedButton;
    StatusBar: TStatusBar;
    SaveButton: TSpeedButton;
    SaveAsButton: TSpeedButton;
    NewButton: TSpeedButton;
    N2: TMenuItem;
    N3: TMenuItem;
    CloseAll1: TMenuItem;
    MDISaveIt1: TMDISaveIt;
    TextMDISaveItType: TMDISaveItType;
    RichMDISaveItType: TMDISaveItType;
    BitmapSaveItType: TMDISaveItType;
    IconSaveItType: TMDISaveItType;
    MetaFileSaveItType: TMDISaveItType;
    AVISaveItType: TMDISaveItType;
    WaveSaveItType: TMDISaveItType;
    PictureSaveItGroup: TMDISaveItGroup;
    MultimediaSaveItGroup: TMDISaveItGroup;
    MidiSaveType: TMDISaveItType;
    PopupMenu1: TPopupMenu;
    rtyt1: TMenuItem;
    CloseButton: TSpeedButton;
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure MDISaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
    procedure MDISaveIt1AllowSaveAs(Sender: TObject; Allowed: Boolean);
    procedure TextMDISaveItTypeFileNew(Sender: TObject;
      var Proceed: Boolean; var NewChild: TForm);
    procedure RichMDISaveItTypeFileNew(Sender: TObject;
      var Proceed: Boolean; var NewChild: TForm);
    procedure BitmapSaveItTypeFileOpen(Sender: TObject;
      var Proceed: Boolean; var NewChild: TForm);
    procedure NewButtonClick(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WaveSaveItTypeFileOpen(Sender: TObject; var Proceed: Boolean;
      var NewChild: TForm);
    procedure FormCreate(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure MDISaveIt1AllowClose(Sender: TObject; Allowed: Boolean);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses Text, RichText, Pic, multimedia;

// *** Begin Ignorable Code ***

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
begin
  MDISaveIt1.MinimizeAll;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  { *** Ignorable Code *** }
  Application.Title := Caption; // Set the App Title to the MainForm's Caption
end;

// *** End Ignorable Code ***

// *** Begin Imporant Code ***

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  MDISaveIt1.Close;
end;

procedure TMainForm.FileOpenItemClick(Sender: TObject);
begin
  MDISaveIt1.Open;
end;

procedure TMainForm.FileSaveItemClick(Sender: TObject);
begin
  MDISaveIt1.Save;
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  MDISaveIt1.SaveAs;
end;

procedure TMainForm.MDISaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
begin
  FileSaveItem.Enabled := Allowed; // Enable/Disable Menu Item
  SaveButton.Enabled   := Allowed; // Enable/Disable Button
end;

procedure TMainForm.MDISaveIt1AllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  FileSaveAsItem.Enabled := Allowed; // Enable/Disable Menu Item
  SaveAsButton.Enabled   := Allowed; // Enable/Disable Button
end;

procedure TMainForm.TextMDISaveItTypeFileNew(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  { create a new MDI child window }
  NewChild := TTextChild.Create(Application);
end;

procedure TMainForm.RichMDISaveItTypeFileNew(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  { create a new MDI child window }
  NewChild := TRichChild.Create(Application);
end;

procedure TMainForm.BitmapSaveItTypeFileOpen(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  { create a new MDI child window }
  NewChild := TPictureChild.Create(Application);
end;

procedure TMainForm.NewButtonClick(Sender: TObject);
begin
  MDISaveIt1.NewDefault;
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
  MDISaveIt1.New;
end;

procedure TMainForm.WaveSaveItTypeFileOpen(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  { create a new MDI child window }
  NewChild := TMultimediaChild.Create(Application);
end;
procedure TMainForm.CloseAll1Click(Sender: TObject);
begin
  MDISaveIt1.CloseAll;
end;

procedure TMainForm.MDISaveIt1AllowClose(Sender: TObject;
  Allowed: Boolean);
begin
  // Enable/Disable Close Buttons and Menu Items
  FileCloseItem.Enabled := Allowed;
  CloseAll1.Enabled := Allowed;
  CloseButton.Enabled := Allowed;

  // Enable/Disable Window Menu
  Window1.Enabled := Allowed;
end;

// *** End Important Code ***

end.

 